<template lang="pug">
loader(:loading="!loaded" title="Loading documents...")
          
  .text-h4.q-pt-md Documents
  
  p.q-my-md.text-body1 Create and manage documents that you want to distribute to break-out rooms during this class.

  div(v-if="!configurationMode")
    p When you click the "Copy and distribute" button:
    ul
      li a copy of each document will be made per group, for them to view and edit.
      li the link to this document will be sent via chat to each break-out room.
      li the copies will be stored in your Google Drive for later access.
    
    q-banner.q-my-md.bg-deep-orange-8.text-white(v-if="botsInBO.length === 0")
      q-icon(size="md" name="warning")
      span.vertical-middle.text-body1 ZoomSensors need to be assigned to breakout rooms in the class before documents can be distributed!

    q-banner.q-my-md.bg-orange-10.text-white(v-else-if="botsInBO.length < meeting.noOfBreakoutRooms")
      q-icon(size="md" name="hourglass_empty")
      span.vertical-middle.text-body1 You can distribute documents now, but only {{botsInBO.length}} of {{meeting.noOfBreakoutRooms}} ZoomSensor(s) are in breakout rooms so far.

    q-banner.q-my-md.bg-positive.text-white(v-else)
      q-icon(size="md" name="done")
      span.vertical-middle.text-body1 You can distribute documents now, as all ZoomSensor(s) are in breakout rooms.
  
  .text-h5.q-pt-md Managed Documents

  div(v-if="Object.keys(gDocsMeeting.documents || {}).length")
    g-doc-tile(v-for="(doc, key) in gDocsMeeting.documents" :doc="doc" :docId="key" :meetingId="meetingId"
      :breakoutRooms="botsInBO" :canDistribute="botsInBO.length > 0" :functions="functions" :key="key"
      v-on="$listeners" :configuration-mode="configurationMode")


  .row.justify-center.full-height.full-width.text-center.items-center(v-else style="color: #ccc; text-align:center;margin:2em;")
          div(style="margin-top:3em;")
            q-icon(name="insert_invitation" style="font-size:10em;")
            p.text-h6 There are no documents for this class.


  q-btn#gdoc-add-btn(type="a" v-on:click="addNewDocument" v-if="!this.isAnonymous" color="primary") Add New Document

</template>

<script lang="ts">
import Vue, { PropType } from "vue";
import * as firebase from "firebase";
import { getGDocsMeetingFirebasePath, GDocsPluginDataMeeting } from "zoomsense-plugin-gdocs-shared";
import { ZoomSenseClientFirebaseDB, ZoomSenseMeeting, ZoomSenseMeetingChatNode } from "@zoomsense/zoomsense-firebase";

// These unassigned imports pull in the relevant typescript definitions of these Vue extensions.
import "vue-cookies";
import "quasar";

import GDocTile from "./GDocTile.vue";
import Loader from "./Loader.vue";

export default Vue.extend({
  name: "ManageDocs",
  props: {
    meetingId: {
      required: true,
      type: String,
    },
    userId: {
      required: true,
      type: String,
    },
    firebase: {
      required: true,
      type: Object as PropType<ZoomSenseClientFirebaseDB>,
    },
    functions: {
      required: true,
      type: Object as PropType<firebase.functions.Functions>,
    },
    configurationMode: {
      type: Boolean,
    },
  },
  data() {
    return {
      meeting: { noOfBreakoutRooms: 0 } as ZoomSenseMeeting,
      gDocsMeeting: {} as GDocsPluginDataMeeting,
      chats: {} as {[zoomSensor: string]: ZoomSenseMeetingChatNode},

      selectedGoogleAccountId: null,
      googleAccs: null,
      gToken: null,
      credential: null,
      authInstance: null,

      gDocId: null,
      findDocResult: null,

      newTitle: null,
      sections: [],
      loaded: false,
    };
  },
  async created() {
    await Promise.all([
      this.$typedRtdbBind("meeting", this.firebase.ref(`meetings/${this.userId}/${this.meetingId}`)),
      this.$typedRtdbBind("gDocsMeeting", this.firebase.ref(getGDocsMeetingFirebasePath(this.meetingId))),
      this.$typedRtdbBind("chats", this.firebase.ref(`data/chats/${this.meetingId}`))
    ]);
    this.loaded = true;
    if (!this.gDocsMeeting.documents) {
      this.gDocsMeeting.documents = {};
    }
  },
  components: {
    GDocTile,
    Loader,
  },
  methods: {
    addNewDocument: function () {
      this.$emit("set-document-id", null);
    },
  },
  computed: {
    botsInBO(): string[] {
      return new Array(this.meeting.noOfBreakoutRooms)
        .fill(null)
        .map((_, index) => (`ZoomSensor_${index + 1}`))
        .filter((sensorId) => (this.chats[sensorId]?.isInBO));
    },
    isAnonymous(): boolean {
      return Boolean(this.$cookies.get("anonymous"));
    },
  },
});
</script>